import pytest
from command_parser import Parser

text = 'This is a [[rate 500]] test.'
@pytest.fixture
def parser():
 p = Parser()
 p.text = text
 return p

def test_Read_until_Returns_string(parser):
 assert parser.read_until(' ') == 'This'

def test_read_command(parser):
 parser.read_until('[[')
 command = parser.read_command()
 assert command == ('rate', '500')

def test_read_remaining(parser):
 parser.read_until('[[')
 parser.read_command()
 assert parser.read_remaining() == ' test.'

def test_parse_basic_string(parser):
 assert parser.parse('testing') == ['testing']

def test_parse_string_with_command(parser):
 assert parser.parse(parser.text) == ['This is a ', ('rate', '500'), ' test.']

def test_parse_just_command(parser):
 assert parser.parse('[[slnc 500]]') == [('slnc', '500')]

def test_read_remaining_at_end(parser):
 parser.text = 'Test [[rate 500]]'
 parser.read_until('[[')
 parser.read_command()
 assert parser.read_remaining() == ''
